import Preferences from './Preferences.js';
import Styles from './Styles.js';

import Menu from './Menu.js';
import Configuration from './Configuration.js';
import Information from './Information.js';


export default class App {

    static init() {
        Preferences.init();
        
        Styles.add(Styles.APP_STYLES, 'midefos-idealista-app-styles');
        if (Preferences.get('darkMode')) {
            Styles.add(Styles.DARK_MODE, 'midefos-idealista-dark-mode');
        }
    
        new Menu();
        new Configuration();
        Information.create();
    }

}